<?php
require 'db1.php'; // Incluye el archivo de conexión a la base de datos


date_default_timezone_set('America/Guayaquil');
// Agregar los encabezados para desactivar la caché
header("Cache-Control: no-cache, no-store, must-revalidate");
header("Pragma: no-cache");
header("Expires: 0");

// Endpoint para obtener datos de la tabla conario
if ($_SERVER['REQUEST_METHOD'] === 'GET') {

    if (isset($_GET['cnv_id'])) {
        $convenio = $_GET['cnv_id'];

        $query = "SELECT * FROM convenio WHERE cnv_id = ?";
        $stmt = $conn->prepare($query);
        $stmt->execute([$convenio]);

        $data = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($data) {
            echo json_encode($data);
        } else {
            echo json_encode(array("message" => "No se encontró ninguna Contrato"));
        }
    } else {
        $query = "SELECT * FROM convenio";
        $stmt = $conn->prepare($query);
        $stmt->execute();
        
        $data = $stmt->fetchAll(PDO::FETCH_ASSOC);
        
        echo json_encode($data);
    }
}

// Endpoint para insertar datos en la tabla conario
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    try {

    $data = json_decode(file_get_contents('php://input'), true);

    $cnv_codigo= $data['cnv_codigo'];
    $cnv_nombre= $data['cnv_nombre'];
    $cnv_fecha_creacion = date('Y-m-d H:i:s'); 
    $cnv_fecha_modificacion = date('Y-m-d H:i:s'); 
    $cnv_estado = 1;
    
    $query = "INSERT INTO convenio (
        cnv_codigo,
        cnv_nombre,
        cnv_fecha_creacion,
        cnv_fecha_modificacion,
        cnv_estado
    ) VALUES (?, ?, ?, ?, ?)";

    $stmt = $conn->prepare($query);
    $stmt->execute([
        $cnv_codigo,
        $cnv_nombre,
        $cnv_fecha_creacion,
        $cnv_fecha_modificacion,
        $cnv_estado
    ]);

    //echo json_encode(array("message" => "0", "inserted_id" => 1));
    
     $insertedId = $conn->lastInsertId(); // Obtén el ID del último registro insertado
     if ($stmt){
        echo json_encode(array("message" => "0", "inserted_id" => intval($insertedId)));
    } else {
        echo json_encode(array("inserted_id" => -2));
    }
    
    } catch (PDOException $e) {
        if ($e->getCode() == 23000) {
            // Código 23000 indica una violación de integridad (clave duplicada)
            echo json_encode(array("message" => "Error: Se intentó ingresar una clave primaria ya existente", "inserted_id" => -3));
        } else {
            // Otro error, imprime el mensaje de la excepción
            echo json_encode(array("message" => "Error: " . $e->getMessage(), "inserted_id" => -2));
        }
    }
}


// Endpoint para actualizar datos en la tabla persona
if ($_SERVER['REQUEST_METHOD'] === 'PUT') {
try {
    if (isset($_GET['cnv_id'])) {
    $data = json_decode(file_get_contents('php://input'), true);
    $cnv_codigo = $data['cnv_codigo']; 
    $cnv_id_anterior = $_GET['cnv_id'];    
    $cnv_id = $data['cnv_id']; // ID del convenio a actualizar
    $cnv_nombre = $data['cnv_nombre'];
    $cnv_fecha_modificacion = date('Y-m-d H:i:s');
    $cnv_estado = 1;
    
    $query = "UPDATE convenio SET
        cnv_codigo = ?,
        cnv_nombre = ?,
        cnv_fecha_modificacion = ?,
        cnv_estado = ?
    WHERE cnv_id = ?";

    $stmt = $conn->prepare($query);
    $stmt->execute([
        $cnv_codigo,
        $cnv_nombre,
        $cnv_fecha_modificacion,
        $cnv_estado,
        $cnv_id_anterior
    ]);

    if ($stmt) {
        echo json_encode(array("inserted_id" => 1));
    } else {
        echo json_encode(array("inserted_id" => -2));
    }
} 
 } catch (PDOException $e) {
        if ($e->getCode() == 23000) {
            // Código 23000 indica una violación de integridad (clave duplicada)
            echo json_encode(array("message" => "Error: Se intentó ingresar una clave primaria ya existente", "inserted_id" => -3));
        } else {
            // Otro error, imprime el mensaje de la excepción
            echo json_encode(array("message" => "Error: " . $e->getMessage(), "inserted_id" => -2));
        }
    }

}

// Endpoint para eliminar un registro de la tabla persona
if ($_SERVER['REQUEST_METHOD'] === 'DELETE') {
    try {
    $data = json_decode(file_get_contents('php://input'), true);

    $cnv_id = $data['cnv_id']; // ID del convenio a eliminar

    $query = "DELETE FROM convenio WHERE cnv_id = ?";

    $stmt = $conn->prepare($query);
    if ($stmt->execute([$cnv_id])) {
        echo json_encode(array("inserted_id" => 1));
    } else {
        echo json_encode(array("inserted_id" => -2));
    }
} catch (PDOException $e) {
     echo json_encode(array("message" => "Error: " . $e->getMessage(), "inserted_id" => -2));
    }
}
$conn = null;
?>